#include "stdafx.h"
#include "wavedev.h"

#define WPDM_PRIVATE_WRITE_AC97_REG 0x00
#define WPDM_PRIVATE_READ_AC97_REG  0x01

void AudioLoopback(BOOL flag)
{
	HANDLE	hPort;
	WORD	x2[10];
	DWORD	x3;
	MMDRV_MESSAGE_PARAMS testParm;

	testParm.uMsg=WPDM_PRIVATE_WRITE_AC97_REG;


	hPort = CreateFile (TEXT("WAV1:"), GENERIC_READ|GENERIC_WRITE,
            			0, NULL, OPEN_EXISTING, 0, NULL);

	if(hPort == INVALID_HANDLE_VALUE) {
		RETAILMSG(1,(TEXT("Can't open WAV:1\r\n")));
	}

	if (flag == TRUE) {
		testParm.dwParam1=0x02;
		testParm.dwParam2=0x0000;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );

		testParm.dwParam1=0x10;
		testParm.dwParam2=0x0808;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );

		testParm.dwParam1=0x1C;
		testParm.dwParam2=0x0000;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );

		testParm.dwParam1=0x1A;
		testParm.dwParam2=0x0404;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );

		testParm.dwParam1=0x20;
		testParm.dwParam2=0x80;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );
	}
	else {
		// Reset
		testParm.dwParam1=0x00;
		testParm.dwParam2=0xFFFF;
		DeviceIoControl(hPort,IOCTL_WAV_MESSAGE,(LPVOID) &testParm, sizeof(MMDRV_MESSAGE_PARAMS),(LPVOID) x2, 10,&x3,NULL );
	}

	CloseHandle(hPort);
}
